<template>
    <v-dialog v-model="showDialog" max-width="600px" persistent hide-overlay>
        <v-card tile :loading="loading">
            <v-toolbar flat dark color="black">
                <v-toolbar-title class="title">{{ dish.id ? dish.name : 'NUEVO PRODUCTO' }}</v-toolbar-title>
                <v-spacer></v-spacer>
                <v-toolbar-items>
                    <v-btn icon dark @click="closeWindow">
                        <v-icon>mdi-close</v-icon>
                    </v-btn>
                </v-toolbar-items>
            </v-toolbar>
            <v-container class="px-7">
                <v-form v-model="valid" lazy-validation ref="form">
                    <v-row>
                        <v-col>
                            <v-text-field
                                v-model="auxDish.name"
                                label="Nombre del producto"
                                :rules="[v => !!v || 'Campo requerido']"
                                required
                            ></v-text-field>
                        </v-col>
                    </v-row>
                    <v-row>
                        <v-col>
                            <v-textarea
                                label="Descripcion del producto"
                                hint="Ejemplo:"
                                rows="4"
                                v-model="auxDish.description"
                            ></v-textarea>
                        </v-col>
                    </v-row>
                    <v-row>
                        <v-col lg="6" cols="12">
                            <v-select
                                label="Categoría"
                                item-value="id"
                                item-text="name"
                                v-model="category"
                                :items="categories"
                                :rules="categoryRules"
                                return-object
                                @input="cat => (auxDish.categoryId = cat.id)"
                            ></v-select>
                        </v-col>
                        <v-col lg="6" cols="12">
                            <v-select
                                label="Subcategoría"
                                item-value="id"
                                item-text="name"
                                v-model="subCategory"
                                :items="initSubCategories()"
                                :rules="subCategoriesRules()"
                                return-object
                                @change="auxDish.subCategoryId = subCategory.id"
                            ></v-select>
                        </v-col>
                    </v-row>
                    <v-row style="margin-top: -2vh;">
                        <v-col>
                            <span class="label">Video</span>
                            <v-text-field
                                v-model="auxDish.video"
                                color="#3b5998"
                                prepend-icon="mdi-video"
                                hint="Ejemplo: https://www.youtube.com/..."
                            ></v-text-field>
                        </v-col>
                        <v-col cols="12">
                            <span class="label">Fotos del producto</span>
                            <GalleryDragAndDrop
                                max="7"
                                resetOffset="5"
                                :files="filesDish"
                                @filesChanged="addDropFile"
                                v-model="auxDish.photos"
                            ></GalleryDragAndDrop>
                        </v-col>
                    </v-row>
                    <v-row style="margin-top: -4vh;">
                        <v-col>
                            <span class="label">Ordenamiento</span>
                            <v-row>
                                <v-col cols="12" lg="4">
                                    <div class="d-flex" style="align-items:center;">
                                        <HexCheckBox v-model="auxDish.active"></HexCheckBox>
                                        <span>¿Activo?</span>
                                    </div>
                                </v-col>
                                <v-col cols="12" lg="4">
                                    <div class="d-flex" style="align-items:center;">
                                        <HexCheckBox v-model="auxDish.mostSelled"></HexCheckBox>
                                        <span>Lo más vendido</span>
                                    </div>
                                </v-col>
                                <v-col cols="12" lg="4">
                                    <div class="d-flex" style="align-items:center;">
                                        <HexCheckBox v-model="auxDish.chefRecommended"></HexCheckBox>
                                        <span>Recomendar</span>
                                    </div>
                                </v-col>
                            </v-row>
                        </v-col>
                    </v-row>
                    <v-row>
                        <v-col cols="12" lg="6">
                            <v-text-field
                                label="Orden de aparición en lista"
                                background-color="#fff"
                                type="number"
                                :value="Number(auxDish.order)"
                                @input="auxDish.order = Number($event)"
                                hide-details
                            ></v-text-field>
                        </v-col>
                        <v-col cols="12" lg="6">
                            <v-text-field
                                label="Prioridad en Recomendados"
                                background-color="#fff"
                                type="number"
                                :value="Number(auxDish.mostSelledPriority)"
                                @input="auxDish.mostSelledPriority = Number($event)"
                                hide-details
                            ></v-text-field>
                        </v-col>
                    </v-row>
                    <v-row>
                        <v-col>
                            <span class="label">Configuraciones por idioma</span>
                            <v-tabs background-color="transparent" grow v-model="tab" class="pb-5">
                                <v-tabs-slider></v-tabs-slider>
                                <v-tab
                                    v-for="(lang, key) in langsMenu"
                                    :key="key"
                                    style="font-weight:bold; font-size: small; border-radius: 0"
                                    :value="key"
                                >
                                    {{ lang.language }}
                                </v-tab>
                            </v-tabs>
                            <v-tabs-items v-model="tab">
                                <v-tab-item v-for="(lang, key) in langsMenu" :key="key" eager>
                                    <v-card flat style="overflow: hidden;">
                                        <v-text-field
                                            label="Nombre del producto"
                                            :value="
                                                langsNameFromComponent.get(lang.id)
                                                    ? langsNameFromComponent.get(lang.id).text
                                                    : undefined
                                            "
                                            @input="changeNameLangText($event, lang.id, lang.language)"
                                            :rules="[v => !!v || 'Campo requerido']"
                                            row-height="20"
                                            rows="2"
                                            auto-grow
                                        ></v-text-field>
                                        <v-textarea
                                            label="Descripción general"
                                            :value="
                                                langsDescriptionFromComponent.get(lang.id)
                                                    ? langsDescriptionFromComponent.get(lang.id).text
                                                    : undefined
                                            "
                                            @input="changeDescriptionLangText($event, lang.id, lang.language)"
                                            row-height="20"
                                            rows="2"
                                            auto-grow
                                        ></v-textarea>
                                        <v-text-field
                                            label="Precio"
                                            type="number"
                                            :value="
                                                pricesFromComponent.get(lang.id)
                                                    ? Number(pricesFromComponent.get(lang.id).amount)
                                                    : undefined
                                            "
                                            @input="changePrice($event, lang.id, lang.currency)"
                                        >
                                        </v-text-field>
                                        <h6 v-if="!valid" style="color: #1976d2;">
                                            *Aún quedan idiomas por configurar
                                        </h6>
                                    </v-card>
                                </v-tab-item>
                            </v-tabs-items>
                        </v-col>
                    </v-row>
                </v-form>
                <v-row>
                    <v-spacer></v-spacer>
                    <v-btn class="add" width="40%" @click="saveDish($event, auxDish)" :disabled="!valid" depressed
                        >Guardar Producto</v-btn
                    >
                </v-row>
                <div style="flex: 1 1 auto; margin-top: -5vh;" v-show="dish.id">
                    <v-form v-model="validIng" lazy-validation ref="formIng">
                        <v-row>
                            <v-col>
                                <span class="label">Categorías del producto</span>
                                <v-card style="background-color: #f3f3f3" height="15vh" flat>
                                    <v-card-text>
                                        <div>
                                            Ingredientes, tallas, colores...
                                        </div>
                                        <v-row>
                                            <v-col lg="9">
                                                <v-text-field
                                                    v-model="auxingredient.name"
                                                    label="Categoría"
                                                    background-color="#fff"
                                                    hide-details
                                                ></v-text-field>
                                            </v-col>
                                            <v-btn
                                                class="add"
                                                depressed
                                                :disabled="!validIng"
                                                @click="createIngredient(auxingredient)"
                                                >Agregar</v-btn
                                            >
                                        </v-row>
                                    </v-card-text>
                                </v-card>
                            </v-col>
                        </v-row>
                    </v-form>
                    <v-row style="margin-top: -2vh;">
                        <v-col>
                            <v-simple-table fixed-header>
                                <template v-slot:default>
                                    <thead>
                                        <tr>
                                            <th class="header text-left">
                                                Categoría
                                            </th>
                                            <th class="header">Obligatorio</th>
                                            <th class="header">Subcategoría</th>
                                            <th class="header">Acciones</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr v-for="ingredient in ingredients" :key="ingredient.id">
                                            <td>{{ ingredient.name }}</td>
                                            <td>
                                                <v-checkbox
                                                    label="Obligatorio"
                                                    color="#f2c94c"
                                                    v-model="ingredient.required"
                                                    @change="mandatoryIngredient(ingredient)"
                                                ></v-checkbox>
                                            </td>
                                            <td style="text-align: center;">
                                                <HexButton
                                                    class="small-button btnHex"
                                                    @click="setExtraDialog(true, ingredient)"
                                                >
                                                    <v-icon>mdi-plus</v-icon>
                                                </HexButton>
                                            </td>
                                            <td>
                                                <v-row>
                                                    <HexButton
                                                        class="small-button btnHex"
                                                        @click="setIngredientDialog(true, ingredient)"
                                                    >
                                                        <v-icon>mdi-pencil</v-icon>
                                                    </HexButton>
                                                    <HexButton
                                                        class="small-button btnHex"
                                                        @click="deleteIngredient(ingredient)"
                                                    >
                                                        <v-icon>mdi-delete</v-icon>
                                                    </HexButton>
                                                </v-row>
                                            </td>
                                        </tr>
                                    </tbody>
                                </template>
                            </v-simple-table>
                        </v-col>
                    </v-row>
                </div>
                <v-snackbar v-model="snack" :timeout="2000">{{ message }}</v-snackbar>
            </v-container>
        </v-card>
        <ExtraIngredients
            :ingredient="ingredient"
            :langs-menu="langsMenu"
            :menu-id="menuId"
            :show-dialog="extraIngredientDialog"
            @saveIngredient="saveIngredient"
            @setIngredientModal="extraIngredientDialog = $event"
            @setMessage="setMessage"
        />
        <Ingredient
            :ingredient="ingredient"
            :langs-menu="langsMenu"
            :menu-id="menuId"
            :show-dialog="ingredientDialog"
            :dish-id="dish.id"
            @saveIngredient="saveIngredient"
            @setIngredientModal="setIngredientDialog($event)"
        />
    </v-dialog>
</template>
<script lang="ts">
import { Component, Prop, Vue, Watch } from 'vue-property-decorator';
import { LangMenu } from '@/model/menu/LangMenu';
import { Dish as DishModel } from '@/model/menu/Dish';
import { Category as CategoryModel, DEFAULT_CATEGORY } from '@/model/menu/Category';
import { LangText } from '@/model/LangText';
import LangList from '@/components/menu/LangList.vue';
import { db } from '@/config/firebase';
import { DISH, DISH_DESCRIPTIONS, DISH_NAMES, DISH_PRICE, INGREDIENTS, MENUS } from '@/config/collectionsName';
import { newTimestamp, serializeIngredient, serializeLangText, serializePrice } from '@/config/serializables';
import { Price } from '@/model/menu/Price';
import Ingredient from '@/components/menu/Ingredient.vue';
import { DEFAULT_INGREDIENT, Ingredient as IngredientModel } from '@/model/menu/Ingredient';
import ExtraIngredients from '@/components/menu/ExtraIngredients.vue';
import HexCheckBox from '@/components/commons/HexCheckBox.vue';
import { isAlpha, isNumericText } from '@/StringUtils';
import GalleryDragAndDrop from '@/components/dishes/GalleryDragAndDrop.vue';
import HexButton from '@/components/commons/HexButton.vue';
import { DishService } from '@/services/DishService';
import { Subcategory as SubCategoryModel } from '@/model/menu/Subcategory';

@Component({ components: { GalleryDragAndDrop, LangList, HexCheckBox, HexButton, Ingredient, ExtraIngredients } })
export default class Dish extends Vue {
    @Prop({
        default: () =>
            new DishModel('', false, '', false, -1, false, '', '', false, -1, '', -1, [], newTimestamp(), '', '')
    })
    dish!: DishModel;
    @Prop({ default: () => [] })
    langsMenu!: LangMenu[];
    @Prop({ default: () => [] })
    categories!: CategoryModel[];
    @Prop({ default: () => ({}) })
    subCategories!: { [key: string]: { subCategories: SubCategoryModel[] } };
    @Prop({ default: false })
    showDialog!: boolean;
    @Prop({ default: '' })
    menuId!: string;
    @Prop({ default: '' })
    action!: string;

    valid = true;
    validIng = true;
    loading = false;
    category: CategoryModel | undefined = DEFAULT_CATEGORY();
    subCategory: SubCategoryModel | undefined = new SubCategoryModel('', false, '', '', 0);
    langsNameFromFire: LangText[] = [];
    langsDescriptionFromFire: LangText[] = [];
    pricesFromFire: Price[] = [];
    ingredients: IngredientModel[] = [];
    langsNameFromComponent: Map<string, LangText> = new Map();
    ingredient: IngredientModel = DEFAULT_INGREDIENT();
    auxingredient: IngredientModel = DEFAULT_INGREDIENT();
    langsDescriptionFromComponent: Map<string, LangText> = new Map();
    pricesFromComponent: Map<string, Price> = new Map();
    fileDish: File[] = [];
    snack = false;
    message = '';
    auxDish = new DishModel('', false, '', false, -1, false, '', '', false, -1, '', -1, [], newTimestamp(), '', '');
    tab = '0';
    ingredientDialog = false;
    extraIngredientDialog = false;
    dishService = new DishService();

    productName = false;
    description = false;
    productPrice = false;
    nameRules = [
        (v: string | undefined) => !!v || 'Nombre de producto es requerido',
        (v: string | undefined) => (v && v.length > 1) || 'Nombre debe tener al menos 2 caracteres',
        (v: string) => isAlpha(v) || 'Nombre de producto no debe contener caracteres especiales'
    ];
    categoryRules = [(v: string | undefined) => !!v || 'Categoria requerida'];

    priorityRules = [
        (v: string) => !!v || 'Orden de aparicion es requerido',
        (v: string) => isNumericText(v) || 'Orden de aparición debe ser un numero mayor a cero'
    ];

    async saveDish(event: Event, dish: DishModel) {
        const isValid = (this.$refs.form as Vue & { validate: () => boolean }).validate();
        if (isValid) {
            if (!this.productName || !this.description || !this.productPrice) {
                const langsNameToFire = Array.from(this.langsNameFromComponent.values()).filter(lang => lang.text);
                const langsDesToFire = Array.from(this.langsDescriptionFromComponent.values()).filter(
                    lang => lang.text
                );
                const priceToFire = Array.from(this.pricesFromComponent.values());

                this.$emit('saveDish', dish, this.fileDish, langsNameToFire, langsDesToFire, priceToFire);
                this.$emit('setShowDishModal', false);
            }
        } else {
            this.setMessage('Aún quedan idiomas por configurar', 'warning', true);
        }
    }

    async closeWindow() {
        this.$emit('setShowDishModal', false);
        this.auxDish = Object.assign(this.auxDish, this.dish);
        (this.$refs.formIng as Vue & { reset: () => '' }).reset();
        if (this.action === 'add' && this.dish.id) {
            (this.$refs.form2 as Vue & { reset: () => '' }).reset();
        }
    }

    async saveIngredient(ingredient: IngredientModel, langIngredient?: LangText[]) {
        if (langIngredient) {
            await this.dishService.updateDishIngredient(this.menuId, ingredient, langIngredient);
            this.setIngredientDialog(false);
            this.setMessage('INGREDIENTE ACTUALIZADO', 'success', true);
            return;
        }
        await this.dishService.updateDishIngredient(this.menuId, ingredient);
        this.setMessage('LIMITE ACTUALIZADO', 'success', true);
        return;
    }

    async createIngredient(ingredient: IngredientModel) {
        const isValid = (this.$refs.formIng as Vue & { validate: () => boolean }).validate();
        if (isValid && !ingredient.id) {
            ingredient.maxAmount = 0;
            ingredient.productId = this.dish.id;
            ingredient.required = false;
            await this.dishService.createDishIngredient(this.menuId, ingredient);
            this.setIngredientDialog(false);
            this.setMessage('INGREDIENTE GUARDADO', 'success', true);
            (this.$refs.formIng as Vue & { reset: () => '' }).reset();
            return;
        }
    }

    subCategoriesRules() {
        const rules = [];
        if (
            this.subCategories[this.auxDish.categoryId] &&
            this.subCategories[this.auxDish.categoryId].subCategories.length > 0
        ) {
            const rule = (v: string) => !!v || 'Campo requerido';
            rules.push(rule);
        }
        return rules;
    }

    setIngredientDialog(show: boolean, ingredient?: IngredientModel) {
        if (ingredient) {
            this.ingredient = ingredient;
        }
        this.ingredientDialog = show;
    }

    setExtraDialog(show: boolean, ingredient: IngredientModel) {
        this.ingredient = ingredient;
        this.extraIngredientDialog = show;
    }

    changeDescriptionLangText(input: string, langId: string, lang: string) {
        this.langsDescriptionFromComponent.set(langId, new LangText(langId, lang, input));
        this.description = lang.length <= 0;
    }

    changeNameLangText(input: string, langId: string, lang: string) {
        this.langsNameFromComponent.set(langId, new LangText(langId, lang, input));
        this.productName = lang.length <= 0;
    }

    changePrice(input: number, langId: string, currency: string) {
        this.pricesFromComponent.set(langId, new Price(langId, Number(input), currency));
        this.productPrice = currency.length <= 0;
    }

    async addDropFile(fileList: File[]) {
        if (fileList) {
            this.fileDish = fileList;
        }
    }

    async deleteIngredient(ingredient: IngredientModel) {
        if (confirm(`¿Deseas eliminar la categoria ${ingredient.name.toUpperCase()}?`)) {
            await this.dishService.deleteDishIngredient(this.menuId, ingredient);
            this.setMessage('INGREDIENTE ELIMINADO', 'info', true);
            return;
        }
    }

    async mandatoryIngredient(ingredient: IngredientModel) {
        if (confirm(`¿Deseas modificar la categoria ${ingredient.name.toUpperCase()}?`)) {
            await this.dishService.updateDishIngredient(this.menuId, ingredient);
            this.setIngredientDialog(false);
            this.setMessage('INGREDIENTE ACTUALIZADO', 'success', true);
            return;
        }
    }

    setMessage(message: string, type: 'success' | 'info' | 'warning' | 'error', show: boolean) {
        this.$emit('setMessage', message, type, show);
    }

    get categoryDish() {
        return this.categories.find(cat => cat.id === this.dish.categoryId);
    }

    @Watch('categories')
    initSubCategories() {
        return this.subCategories[this.auxDish.categoryId]
            ? this.subCategories[this.auxDish.categoryId].subCategories
            : [];
    }

    get filesDish() {
        return this.dish.photos;
    }

    @Watch('dish')
    async onDishChange(newDish: DishModel | null) {
        this.loading = true;
        if (newDish && newDish.id) {
            await this.$bind(
                'langsNameFromFire',
                db
                    .collection(MENUS)
                    .doc(this.menuId)
                    .collection(DISH)
                    .doc(this.dish.id)
                    .collection(DISH_NAMES),
                { serialize: serializeLangText }
            );

            await this.$bind(
                'langsDescriptionFromFire',
                db
                    .collection(MENUS)
                    .doc(this.menuId)
                    .collection(DISH)
                    .doc(this.dish.id)
                    .collection(DISH_DESCRIPTIONS),
                { serialize: serializeLangText }
            );

            await this.$bind(
                'pricesFromFire',
                db
                    .collection(MENUS)
                    .doc(this.menuId)
                    .collection(DISH)
                    .doc(this.dish.id)
                    .collection(DISH_PRICE),
                { serialize: serializePrice }
            );

            await this.$bind(
                'ingredients',
                db
                    .collection(MENUS)
                    .doc(this.menuId)
                    .collection(INGREDIENTS)
                    .where('productId', '==', this.dish.id),
                { serialize: serializeIngredient }
            );
        }

        if (!newDish?.id) {
            this.langsNameFromFire = [];
            this.langsDescriptionFromFire = [];
            this.pricesFromFire = [];
            this.ingredients = [];
            this.fileDish = [];
        }
        if (newDish?.photos) {
            this.fileDish = newDish.photos.map(photo => new File([], photo || ''));
        }
        this.langsDescriptionFromComponent = new Map();
        this.langsNameFromComponent = new Map();
        this.pricesFromComponent = new Map();
        this.category = DEFAULT_CATEGORY();
        this.subCategory = new SubCategoryModel('', false, '', '', 0);
        this.auxingredient = DEFAULT_INGREDIENT();
        this.langsDescriptionFromFire.forEach(langDescription =>
            this.langsDescriptionFromComponent.set(langDescription.id, langDescription)
        );
        this.langsNameFromFire.forEach(langName => this.langsNameFromComponent.set(langName.id, langName));
        this.pricesFromFire.forEach(price => this.pricesFromComponent.set(price.id, price));
        this.auxDish = Object.assign(this.auxDish, this.dish);
        this.category = this.categories.find(cat => cat.id === this.dish.categoryId);
        this.subCategory = this.subCategories[this.auxDish.categoryId]
            ? this.subCategories[this.auxDish.categoryId].subCategories.find(x => x.id === this.auxDish.subCategoryId)
            : undefined;
        this.loading = false;
    }
}
</script>

<style type="scss">
.title {
    text-transform: uppercase;
}
.label {
    font-weight: 500;
    font-size: 16px;
    line-height: 7vh;
}
.header {
    background-color: transparent !important;
    color: #f2c94c !important;
}
.add {
    margin: 25px 0;
    border-radius: 6px;
    text-transform: capitalize;
    color: #fff !important;
    background-color: #feca38 !important;
}
</style>
